
ifndef ARCH
ARCH:=${shell uname -m}
endif

# cannot just use $ARCH-linux- , can be -unknown-linux-uclibc- ...
ifeq ($(ARCH),mipsel)
ARCHPREFIX:=mipsel-linux-
endif
ifeq ($(ARCH),ppc)
ARCHPREFIX:=powerpc-linux-
endif

INCLUDES   =  -I../include/ -I../../wbCommons/
CC := $(ARCHPREFIX)gcc
CXX:= $(ARCHPREFIX)g++
AR := $(ARCHPREFIX)ar

override CFLAGS+=-g -Wall
override CXXFLAGS+=-g -Wall $(INCLUDES)

# TODO: à virer, remplacer par libwbcommons-$ARCH.a

SOURCES :=  $(wildcard ../../wbCommons/*.c)
HEADERS :=  $(wildcard ../../wbCommons/*.h) 
OBJECTS := $(SOURCES:.c=.o)

.PHONY: all libwbClient clean cleanobjs

all: libwbClient test_client1-$(ARCH) test_client2-$(ARCH) test_pantilt1-$(ARCH)

libwbClient: wb_client.o wb_pantilt.o $(OBJECTS)
	$(AR) cr libwbClient-$(ARCH).a wb_client.o wb_pantilt.o $(SOURCES)
	$(CXX) $(LIBS) -shared wb_client.o wb_pantilt.o -o libwbClient-$(ARCH).so $(SOURCES)

test_client1-$(ARCH): test_client1.cc libwbClient
	$(CXX) test_client1.cc -o test_client1-$(ARCH) -L./ -lwbClient-$(ARCH) -Wl,-rpath,.

test_client2-$(ARCH): test_client2.c libwbClient
	$(CXX) $(INCLUDES) test_client2.c -o test_client2-$(ARCH) -L./ -lwbClient-$(ARCH) -Wl,-rpath,.

test_pantilt1-$(ARCH): test_pantilt1.cc libwbClient
	$(CXX) test_pantilt1.cc -o test_pantilt1-$(ARCH) -L./ -lwbClient-$(ARCH) -Wl,-rpath,.

clean:
	rm -vf *.o
	# dangerous * :-)
	rm -vf test_client2-*
	rm -vf test_client1-*
	rm -vf test_pantilt1-*
	rm -vf libwbClient-*.so libwbClient-*.a

cleanobjs:
	rm -vf *.o
